property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "TablePopupCells"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:%20TablePopupCells%20(v" & script_version & ")"
property script_contribution_url : "https://order.kagi.com/?ELJ"

property first_run : true
property run_plead : true
property the_setting_names : {"first_run", "run_plead"}

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
			set the_table to table view 1 of scroll view 1
			--this assumes there's already a data source
			set the_table_data_source to data source of the_table
			set the_data_cell to data cell 1 of table column 2 of the_table
			call method "removeAllItems" of the_data_cell
			call method "addItemsWithTitles:" of the_data_cell with parameter {"item 1", "item 2", "item 3", "item 4"}
			tell the_data_cell
				set bordered to true
				set bezel style to rounded bezel
				--shadowless square bezel/disclosure bezel/thicker square bezel/rounded bezel/help button bezel/circular bezel/thick square bezel/textured square bezel/regular square beze
				--set control size to small size --regular size/small size/mini size
			end tell
			tell the_table_data_source
				try
					delete data rows
				end try
				try
					delete data columns
				end try
				make new data column at end of data columns with properties {name:"column_1"}
				make new data column at end of data columns with properties {name:"column_2"}
				repeat with i from 1 to 4
					set this_row to make new data row at end of data rows
					tell this_row
						set contents of data cell "column_1" to ("Value " & (i as Unicode text))
						set content of data cell "column_2" to (i - 1) --this is the zero based index of the menu items
					end tell
				end repeat
			end tell
		end tell
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & script_release_date)
				set contents of text field "copyright" to (script_copyright)
				set state of button "run_plead" to run_plead as integer
			end tell
		end tell
		
	end if
end awake from nib

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	try
		set true_or_false to state of the_object as boolean
	end try
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "contribute" then
		open location script_contribution_url
		
	else if object_name = "run_plead" then
		set run_plead to true_or_false
		my write_settings()
		
	else if object_name = "get_values" then
		set the_table to table view 1 of scroll view 1 of window of the_object
		set the_table_data_source to data source of the_table
		set the_values to contents of data cells of data rows of the_table_data_source
		set old_delim to my text item delimiters
		set my text item delimiters to {" = "}
		repeat with i from 1 to (count the_values)
			set item i of the_values to ("" & item i of the_values)
		end repeat
		set my text item delimiters to {return}
		set the_values to "" & the_values
		set my text item delimiters to old_delim
		my display_message("The Values", the_values)
		
	end if
end clicked

on will open the_object
	try
		set {x, y} to (get size of window "main")
		set size of the_object to {x, y - 22}
	end try
	return true
end will open

on will quit the_object
	my quit_prep()
	return true
end will quit

on close_all_panels()
	try
		set the_panels to windows whose class = panel and visible = true
		repeat with this_panel in the_panels
			try
				if name of this_panel  "main" then close panel this_panel
			on error
				close panel this_panel
			end try
		end repeat
	end try
end close_all_panels

on quit_prep()
	my close_all_panels()
	my get_settings()
	my write_settings()
	if run_plead then my plead()
	set quitting to true
end quit_prep

on display_message(the_title, the_message)
	activate
	display alert the_title as informational message the_message default button "OK" attached to window "main"
end display_message

on display_warning(the_warning, the_buttons, default_button)
	activate
	beep
	return button returned of (display dialog the_warning buttons the_buttons default button default_button with icon 2)
end display_warning

on assign_settings(the_settings)
	set {first_run, run_plead} to the_settings
end assign_settings

on get_settings()
	tell window "main"
		--set xx to contents of text field "xx"
	end tell
	return {first_run, run_plead}
end get_settings

on register_settings()
	set the_settings to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				make new default entry at end of default entries with properties {name:(item i of the_setting_names), contents:(item i of the_settings)}
			end try
		end repeat
		register
	end tell
end register_settings

on read_settings()
	set the_settings to {}
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				set end of the_settings to contents of default entry (item i of the_setting_names)
			end try
		end repeat
	end tell
	my assign_settings(the_settings)
end read_settings

on write_settings()
	set the_settings to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				set contents of default entry (item i of the_setting_names) to (item i of the_settings)
			end try
		end repeat
	end tell
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status

on plead()
	tell application "System Events"
		activate
		set the_button to button returned of (display dialog "If you found this useful, and I hope you did, please consider contributing to my webhosting and general development costs. (You may disable this reminder in the About box.)" buttons {"Maybe Later", "Contribute Now"} default button 2 with icon 1)
	end tell
	if the_button = "Contribute Now" then open location script_contribution_url
end plead
